/********************************** (C) COPYRIGHT *******************************

 * File Name          : main.c

 * Author             : WCH

 * Version            : V1.0.0

 * Date               : 2021/06/06

 * Description        : Main program body.

 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.

 * SPDX-License-Identifier: Apache-2.0

 *******************************************************************************/



/*

 *@Note

 Զעģʽ̣

 ADCͨ1(PA1)-ͨͨ3(PA3)-עͨ



*/



#include "debug.h"




void ADC1_2_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));

/*******************************************************************************
* Function Name  : ADC_Function_Init
* Description    : Initializes ADC collection.
* Input          : None
* Return         : None
*******************************************************************************/
void ADC_Function_Init(void)
{
    GPIO_InitTypeDef  GPIO_InitStructure={0};
    ADC_InitTypeDef   ADC_InitStructure={0};
    NVIC_InitTypeDef  NVIC_InitStructure={0};

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA|RCC_APB2Periph_ADC1, ENABLE );

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN;
    GPIO_Init(GPIOA, &GPIO_InitStructure);

    RCC_ADCCLKConfig(RCC_PCLK2_Div6);
    ADC_DeInit(ADC1);
    ADC_InitStructure.ADC_Mode = ADC_Mode_Independent;
    ADC_InitStructure.ADC_ScanConvMode = DISABLE;
    ADC_InitStructure.ADC_ContinuousConvMode = DISABLE;
    ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrigInjecConv_T1_TRGO;;
    ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right;
    ADC_InitStructure.ADC_NbrOfChannel = 0;
    ADC_Init(ADC1, &ADC_InitStructure);

    //עͨ
    //ADC_InjectedDiscModeCmd(ADC1,DISABLE);   //ADC1עͨģʽ
    ADC_InjectedSequencerLengthConfig(ADC1, 2);                                          //עͨг
    ADC_InjectedChannelConfig(ADC1, ADC_Channel_1, 1, ADC_SampleTime_239Cycles5);        //ΪѡADCעͨת˳ʱ䡣
    ADC_InjectedChannelConfig(ADC1, ADC_Channel_2, 2, ADC_SampleTime_239Cycles5);        //ΪѡADCעͨת˳ʱ䡣
    ADC_ExternalTrigInjectedConvConfig(ADC1, ADC_ExternalTrigInjecConv_T1_TRGO);         //עͨⲿ˴ѡTIM1
    ADC_ExternalTrigInjectedConvCmd(ADC1, ENABLE);                                       //ͨⲿעͨת
    //ADC_AutoInjectedConvCmd(ADC1, DISABLE); //رעͨڹת֮Զת

    NVIC_InitStructure.NVIC_IRQChannel = ADC1_2_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 2;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);

    ADC_ITConfig( ADC1, ADC_IT_JEOC, ENABLE);
    ADC_Cmd(ADC1, ENABLE);

    ADC_ResetCalibration(ADC1);
    while(ADC_GetResetCalibrationStatus(ADC1));
    ADC_StartCalibration(ADC1);
    while(ADC_GetCalibrationStatus(ADC1));
    ADC_SoftwareStartConvCmd(ADC1, ENABLE);
}

/*******************************************************************************
* Function Name  : EXTI_Event_Init
* Description    : Initializes EXTI.
* Input          : None
* Return         : None
*******************************************************************************/
void TIM1_INIT(void)
{

    TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStructure = { 0 };

    //ʱ1ˢʱ䴥AD

    RCC_APB2PeriphClockCmd( RCC_APB2Periph_TIM1, ENABLE);

    TIM_TimeBaseInitStructure.TIM_Period = 56250; //=72000000/12800
    TIM_TimeBaseInitStructure.TIM_Prescaler = 0;  //Ƶ
    TIM_TimeBaseInitStructure.TIM_ClockDivision = TIM_CKD_DIV4;
    TIM_TimeBaseInitStructure.TIM_CounterMode = TIM_CounterMode_Up;
    TIM_TimeBaseInit(TIM1, &TIM_TimeBaseInitStructure);

//    TIM_CtrlPWMOutputs(TIM1, ENABLE);
//    TIM_ARRPreloadConfig(TIM1, ENABLE);
    TIM_SelectOutputTrigger(TIM1, TIM_TRGOSource_Update);
    TIM_Cmd(TIM1, ENABLE);

}

/*******************************************************************************
* Function Name  : ADC1_2_IRQHandler
* Description    : This function handles analog watchdog exception.
* Input          : None
* Return         : None
*******************************************************************************/
void ADC1_2_IRQHandler()
{

    u16 jadc1;
    u16 jadc2;

    if(ADC_GetITStatus( ADC1, ADC_IT_JEOC))
    {
        printf("ADCⲿעת\r\n");
        jadc1 = ADC_GetInjectedConversionValue(ADC1, ADC_InjectedChannel_1);
        jadc2 = ADC_GetInjectedConversionValue(ADC1, ADC_InjectedChannel_2);
        printf( "jadc1=%d\r\n", jadc1 );
        printf( "jadc2=%d\r\n", jadc2 );
        printf( "\r\n");
    }

    ADC_ClearITPendingBit( ADC1, ADC_IT_JEOC);
}


/*********************************************************************

 * @fn      main

 *

 * @brief   Main program.

 *

 * @return  none

 */

int main(void)

{



    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
    Delay_Init();

    USART_Printf_Init(115200);

    printf("SystemClk:%d\r\n",SystemCoreClock);
        printf("This is ADC example\r\n");
        ADC_Function_Init();
           TIM1_INIT();
    while(1)

    {


    }

}



